.arm
.text
.global main

main:
STMDB R13!,{R0-R12,R14}
/*--Init Registers--*/
LDR R0,=DecData
LDMIA R0,{R1,R2}		@R1=V[0],R2=V[1]
LDR R0,=Key
LDMIA R0,{R4-R7}		@R4=K[0]...R7=K[3]
LDR R0,=Delta
LDR R9,[R0]				@R9=Delta
B Encrypt
EndEnc:
LDR R0,=EncData
STMIA R0,{R1,R2}		@Store encrypt result
EndDec:
LDR R0,=DecData
STMIA R0,{R1,R2}		@Store decrypted result

LDMIA R13!,{R0-R12,PC} 

Encrypt:
MOV R3,#0x0				@Sum=0
MOV R8,#0x20			@Counter=32
/*--Encrypt Loos--*/
EncLoop:
ADD R3,R3,R9			@SUM=SUM+DELTA
/* V[0]+=((V[1]<<4)+K[0])^(V[1]+SUM)^((V[1]>>5)+K[1]) */
MOV R0,R2,LSL #4		@R0=V[1]<<4
ADD R10,R0,R4			@R10=(V[1]<<4)+K[0]
ADD R11,R2,R3			@R11=V[1]+SUM
MOV R0,R2,LSR #5		@R0=V[1]>>5
ADD	R12,R0,R5			@R12=(V[1]>>5)+K[1]
EOR	R10,R10,R11			@R10=R10^R11
EOR	R10,R10,R12			@R10=R10^R12
ADD R1,R1,R10			@V[0]=V[0]+R10
/* V[1]+=((V[0]<<4)+K[2])^(V[0]+SUM)^((V[0]>>5)+K[3]) */
MOV R0,R1,LSL #4		@R0=V[0]<<4
ADD R10,R0,R6			@R10=(V[0]<<4)+K[2]
ADD	R11,R1,R3			@R11=V[0]+SUM
MOV R0,R1,LSR #5		@R0=V[0]>>5
ADD R12,R0,R7			@R12=(V[0]>>5)+K[3]
EOR	R10,R10,R11			@R10=R10^R11
EOR	R10,R10,R12			@R10=R10^R12
ADD R2,R2,R10			@V[1]=V[1]+R10
/* Decrease loop counter & compare with zero */
SUBS R8,R8,#1
CMP R8,#0
BNE EncLoop				@If counter>0 loop
B EndEnc				@Return to main


Decrypt:
MOV R3,R9,LSL #5		@SUM=Delta<<5
MOV R8,#0x20			@Counter=32
LDR R0,=EncData			@load encrypted data
LDMIA R0,{R1,R2}
DecLoop:
/* V[1]-=((V[0]<<4)+K[2])^(V[0]+SUM)^((V[0]>>5)+K[3]) */
MOV R0,R1,LSL #4		@R0=V[0]<<4
ADD R10,R0,R6			@R10=(V[0]<<4)+K[2]
ADD R11,R1,R3			@R11=V[0]+SUM
MOV R0,R1,LSR #5		@R0=V[0]>>5
ADD R12,R0,R7			@R12=(V[0]>>5)+K[3]
EOR R10,R10,R11			@R10=R10^R11
EOR R10,R10,R12			@R10=R10^R12
SUB R2,R2,R10			@V[1]=V[1]-R10
/* V[0]-=((V[1]<<4)+K[0])^(V[1]+SUM)^((V[1]>>5)+K[1]) */
MOV R0,R2,LSL #4		@R0=V[1]<<4
ADD R10,R0,R4			@R10=(V[1]<<4)+K[0]
ADD R11,R2,R3			@R11=V[1]+SUM
MOV R0,R2,LSR #5		@R0=V[1]>>5
ADD R12,R0,R5			@R12=(V[1]>>5)+K[1]
EOR R10,R10,R11			@R10=R10^R11
EOR R10,R10,R11			@R10=R10^R12
SUB R1,R1,R10			@V[0]=V[0]-R10
SUB R3,R3,R9			@SUM=SUM-Delta
/* Decrease loop counter & compare with zero */
SUBS R8,R8,#1
CMP R8,#0
BNE DecLoop				@If counter>0 loop
B EndDec				@Return to main

.data
DecData:
.word 0x01234567
.word 0x89ABCDEF
Delta:
.word 0x9E3779B9
Key:
.word 0x00112233
.word 0x44556677
.word 0x8899AABB
.word 0xCCDDEEFF
EncData:
.word 0,0
